/****       *  END LINE  *       ****/

#include "convert.h"

// convert end-line style
int convert_end_line(in_char, in_end_line_type, out_type, out_end_line_type, out_file)
/* 
	function return:
	* 0 if sucsessfull
	* 1 if in-out type error
	* 3 if END_LINE_ERR
	OR error of convert_out function
*/
	Char	in_char;
	char	in_end_line_type;

	char	out_type;
	char	out_end_line_type;
	FILE	*out_file;
{
	if (out_end_line_type == NOT || in_end_line_type == out_end_line_type) {
		return convert_out(in_char, out_type, out_file);
	} else {
		if ( in_end_line_type == NOT ) {
			// END_LINE_ERR
			return 3;
		}
		// swich in end line style
		switch (in_end_line_type) {
			case LF:
				if (in_char==0x0a) {
					// output encoding detect
					if ( out_end_line_type == CR ) {
						in_char = 0x0d;
						convert_out(in_char, out_type, out_file);
					} else if ( out_end_line_type == CRLF ) {
						in_char = 0x0d;
						convert_out(in_char, out_type, out_file);
						in_char = 0x0a;
						convert_out(in_char, out_type, out_file);
					} else {
						return 1;
					}
				} else {
					return convert_out(in_char, out_type, out_file);
				}
			break;
			case CRLF:
				if (in_char==0x0d) {
					// output encoding detect
					if ( out_end_line_type == LF ) {
						in_char = 0x0a;
						convert_out(in_char, out_type, out_file);
					} else if ( out_end_line_type == CR ) {
						in_char = 0x0d;
						convert_out(in_char, out_type, out_file);
					} else {
						return 1;
					}
				} else if (in_char==0x0a) {
					// output encoding detect
					if ( out_end_line_type == LF || out_end_line_type == CR ) {
						return 0;
					} else {
						return 1;
					}
				} else {
					return convert_out(in_char, out_type, out_file);
				}
			break;
			case CR:
				if (in_char==0x0d) {
					// output encoding detect
					if ( out_end_line_type == LF ) {
						in_char = 0x0a;
						convert_out(in_char, out_type, out_file);
					} else if ( out_end_line_type == CRLF ) {
						in_char = 0x0d;
						convert_out(in_char, out_type, out_file);
						in_char = 0x0a;
						convert_out(in_char, out_type, out_file);
					} else {
						return 1;
					}
				} else {
					return convert_out(in_char, out_type, out_file);
				}
			break;
			default:
				// in-out type error
				return 1;
			break;
		}
	}
}